using System;
using System.Web;
using System.Collections;

namespace ShoppingCartGeneric
{
	public class CCookieShoppingCart:IShoppingCart
	{

		public int Add(string cartid, IShoppingCartItem item)
		{
			HttpCookie c=null;
			if(HttpContext.Current.Request.Cookies["shoppingcart"]==null)
				c=new HttpCookie("shoppingcart");
			else
				c=HttpContext.Current.Request.Cookies["shoppingcart"];
			string itemdetails;
			itemdetails=item.ProductID + "|" + item.ProductName + "|" + item.UnitPrice;
			c.Values[item.ProductID.ToString()]=itemdetails;
			HttpContext.Current.Response.Cookies.Add(c);
			return 1;
		}

		public int Remove(string cartid, IShoppingCartItem item)
		{
			HttpCookie c=HttpContext.Current.Request.Cookies["shoppingcart"];
			c.Values.Remove(item.ProductID.ToString());
			HttpContext.Current.Response.Cookies.Add(c);
			return 1;
		}

		public ArrayList GetItems(string cartid)
		{
			HttpCookie c=HttpContext.Current.Request.Cookies["shoppingcart"];
			ArrayList items=new ArrayList();

			for(int i=0;i<c.Values.Count;i++)
			{
				string[] vals=c.Values[i].Split('|');
				CShoppingCartItem item=new CShoppingCartItem();
				item.ProductID=int.Parse(vals[0]);
				item.ProductName=vals[1];
				item.UnitPrice=decimal.Parse(vals[2]);
				item.Quantity=1;

				items.Add(item);
			}
			return items;
		}

	}
}
