using System;
using System.Data;
using System.Data.SqlClient;
using System.Collections;

namespace ShoppingCartGeneric
{
	public class CDatabaseShoppingCart:IShoppingCart
	{
		private static string connstr=@"data source=.\vsdotnet;initial catalog=northwind;user id=sa";

		public int Add(string cartid, IShoppingCartItem item)
		{
			SqlConnection cnn=new SqlConnection(connstr);
			SqlCommand cmd=new SqlCommand();
			cmd.Connection=cnn;
			cmd.CommandText="insert into ShoppingCart_Products(cartid,productid,productname,unitprice,quantity) values(@cartid,@prodid,@prodname,@unitprice,@qty)";

			SqlParameter p1=new SqlParameter("@cartid",cartid);
			SqlParameter p2=new SqlParameter("@prodid",item.ProductID);
			SqlParameter p3=new SqlParameter("@prodname",item.ProductName);
			SqlParameter p4=new SqlParameter("@unitprice",item.UnitPrice);
			SqlParameter p5=new SqlParameter("@qty",item.Quantity);

			cmd.Parameters.Add(p1);
			cmd.Parameters.Add(p2);
			cmd.Parameters.Add(p3);
			cmd.Parameters.Add(p4);
			cmd.Parameters.Add(p5);

			cnn.Open();
			cmd.ExecuteNonQuery();
			cnn.Close();

			return 0;
		}

		public void UpdateQuantity(string cartid,int productid,int newqty)
		{
			SqlConnection cnn=new SqlConnection(connstr);
			SqlCommand cmd=new SqlCommand();
			cmd.Connection=cnn;
			cmd.CommandText="update ShoppingCart_Products set quantity=@qty where cartid=@cartid and productid=@prodid";

			SqlParameter p1=new SqlParameter("@qty",newqty);
			SqlParameter p2=new SqlParameter("@cartid",cartid);
			SqlParameter p3=new SqlParameter("@prodid",productid);

			cmd.Parameters.Add(p1);
			cmd.Parameters.Add(p2);
			cmd.Parameters.Add(p3);

			cnn.Open();
			cmd.ExecuteNonQuery();
			cnn.Close();

		}

		public int Remove(string cartid, IShoppingCartItem item)
		{
			SqlConnection cnn=new SqlConnection(connstr);
			SqlCommand cmd=new SqlCommand();
			cmd.Connection=cnn;
			cmd.CommandText="delete from ShoppingCart_Products where cartid=@cartid and productid=@prodid";

			SqlParameter p1=new SqlParameter("@cartid",cartid);
			SqlParameter p2=new SqlParameter("@prodid",item.ProductID);

			cmd.Parameters.Add(p1);
			cmd.Parameters.Add(p2);

			cnn.Open();

			cmd.ExecuteNonQuery();

			cnn.Close();
			return 0;
		}

		public System.Collections.ArrayList GetItems(string cartid)
		{
			SqlDataAdapter da=new SqlDataAdapter("select * from ShoppingCart_Products where cartid='" + cartid + "'",connstr);
			DataSet ds=new DataSet();
			da.Fill(ds,"shoppingcart");	
			
			ArrayList arr=new ArrayList();
			foreach(DataRow row in ds.Tables[0].Rows)
			{
				CShoppingCartItem item=new CShoppingCartItem();
				item.ProductID=(int)row["productid"];
				item.ProductName=(String)row["productname"];
				item.Quantity=(int)row["quantity"];
				item.UnitPrice=(Decimal)row["unitproce"];
				arr.Add(item);
			}
			return arr;
		}

	}
}
