using System;

namespace ShoppingCartGeneric
{
	public enum CShoppingCartType
	{
		Cookie,Session,Database
	}

	public class CShoppingCart:IShoppingCart
	{
		private IShoppingCart cart=null;

		public CShoppingCart(CShoppingCartType type)
		{
			switch(type)
			{
				case CShoppingCartType.Cookie:
					cart=new CCookieShoppingCart();
					break;
				case CShoppingCartType.Session:
					cart=new CSessionShoppingCart();
					break;
				case CShoppingCartType.Database:
					cart=new CDatabaseShoppingCart();
					break;
			}
		}

		public int Add(string cartid, IShoppingCartItem item)
		{
			return cart.Add(cartid,item);
		}

		public int Remove(string cartid, IShoppingCartItem item)
		{
			return cart.Remove(cartid,item);
		}

		public System.Collections.ArrayList GetItems(string cartid)
		{
			return cart.GetItems(cartid);
		}

	}
}
